/// <reference types="react" />
export declare type LoFHighlightStyleSheet = {
    cross: React.CSSProperties;
    content: React.CSSProperties;
    spaceId: React.CSSProperties;
    reentry: React.CSSProperties;
    error: React.CSSProperties;
};
export declare const defaultStyle: LoFHighlightStyleSheet;
/**
 * @param {children} expression - Bracket Expression LoF String e.g ((b)(a)c)
 * @param {LoFHighlightStyleSheet} highlighting - Custom style sheet for syntax highlighted
 *
 * Syntax Highlighting of the given expression.
 */
export default function SyntaxHighlighting({ children, highlighting, }: {
    children: string;
    highlighting?: LoFHighlightStyleSheet;
}): JSX.Element;
